/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Tabbrowser Extensions.
 *
 * The Initial Developer of the Original Code is SHIMODA Hiroshi.
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): SHIMODA Hiroshi <piro@p.club.ne.jp>
 *                 Sebastian Lisken <sebastian.lisken@uni-bielefeld.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/* clean up the datasource automatically (sometimes make the startup slow) */
pref("browser.tabs.extensions.auto_cleanUp",       true);
pref("browser.tabs.extensions.auto_cleanUp_count", 0);
/* If "browser.tabs.extensions.auto_cleanUp" is enabled, the counter increases by startup. and when the counter reaches 9, the datasource is cleaned up. */


/* expert prefs mode */
pref("browser.tabs.extensions.expert_prefs", false);

pref("browser.tabs.extensions.autoConfigDDESupport",              false);
pref("browser.tabs.extensions.autoConfigDDESupport_firstConfirm", false);


// In some environments, "window.close" crashs Mozilla.
// We have to use setTimeout to avoid this problem if "window.close" makes a crash.
pref("browser.tabs.extensions.window_auto_close_timeout", false);


pref("browser.tabs.extensions.tab_menu.show",                       true);
pref("browser.tabs.extensions.prevent_same_uri_tab",                false);
pref("browser.tabs.extensions.open_first_in_current",               true);
pref("browser.tabs.extensions.show_link_text_as_label",             true);
pref("browser.tabs.extensions.show_link_text_as_label_permanently", false);
pref("browser.tabs.extensions.openURIString_with_dblclick",         true);

pref("browser.tabs.extensions.undo_cache.backup.enabled", true);
pref("browser.tabs.extensions.undo_cache.local",          30);
pref("browser.tabs.extensions.undo_cache.global",         50);


/* window mode
	0 = normal (open other windows)
	1 = hook only requests from content window and other apps
	2 = hook any request include requests from XUL windows
	2 is "single window mode"
*/
pref("browser.tabs.extensions.window_hook_mode",            0);
pref("browser.tabs.extensions.sameness_shell_as_a_program", false);

/* startup page of tabs (for 1.4a or earlier)
	-1 = same to Navigator's startup page
	0  = blank
	1  = home
	2  = last visited

	this setting is replaced to "browser.tabs.loadOnNewTab" in 1.4b or later
*/
pref("browser.tabs.extensions.startup.page",               0);

pref("browser.tabs.extensions.clear_location_bar",         true);
// to close windows with several tabs: -1 = ask always, 0 = allow, 1 = forbid, 2 = save all tabs
pref("browser.tabs.extensions.cancel_windowclose",         -1);
pref("browser.tabs.extensions.restore_last_visited_tabs",  true);
pref("browser.tabs.extensions.restore_last_visited_tabs_ignore_OpenURL_requests", true);
pref("browser.tabs.extensions.restore_last_visited_tabs_one_time", false);
pref("browser.tabs.extensions.restore_last_visited_tabs_one_time.hide_changemode_alert", false);
pref("browser.tabs.extensions.restore_last_visited_tabs_one_time.hide_alert", false);
pref("browser.tabs.extensions.autosave_tabset.hide_alert", false);
pref("browser.tabs.extensions.copy_recent_tabs",           false);
pref("browser.tabs.extensions.backup_tabs",                true);
pref("browser.tabs.extensions.backup_tabs_confirm_hidden", false);

pref("browser.tabs.opentabfor.bookmarks",                   true);
pref("browser.tabs.opentabfor.bookmarks_folder_as_group",   true);
pref("browser.tabs.extensions.emulate_middle_click",        false);
pref("browser.tabs.opentabfor.history",                     true);
pref("browser.tabs.opentabfor.linkclick",                   false);
pref("browser.tabs.opentabfor.openURIString_with_dblclick", false);
pref("browser.tabs.opentabfor.windowopen",                  false);
pref("browser.tabs.opentabfor.native_apps",                 false);


pref("browser.tabs.extensions.show_closebox.tabbar",            true);
pref("browser.tabs.extensions.show_scrollbar",                  true);
pref("browser.tabs.extensions.tabbar_place",                    0);
// 0 = hide tabbar, 1 = unload the tab, 2 = ignore
pref("browser.tabs.extensions.last_tab_closing",                0);
pref("browser.tabs.extensions.limit.number",                    0);
pref("browser.tabs.extensions.limit.overflow",                  true);
pref("browser.tabs.extensions.switch_tabs_by_wheel",            true);

/*
	0   = none
	1   = New Tab
	2   = Reload Tab
	3   = Reload All Tabs
	4   = Close Tab
	5   = Close Other Tabs
	6   = Bookmark Group of Tabs as a Bookmark-Group

	101 = Duplicate Tab
	102 = Lock Tab
	103 = Auto Reload
	104 = Close Left Tabs
	105 = Close Right Tabs
	106 = Duplicate Tab in New Window
	107 = Move to Left
	108 = Move to Right
	109 = Close Group of Tabs
	110 = Sort Tabs by Group
	111 = Highlight Group of Tabs
	112 = Set Group Color
	113 = Undo Close Tab
	114 = Edit Bookmark
	115 = Block Referrer
	116 = Edit Context Menu
	117 = Remove All Tabs
	118 = Set Label
	119 = Remove Visited Tabs

	200 = Allow/Forbid Plugins
	201 = Allow/Forbid JavaScript
	202 = Allow/Forbid Redirects by Meta
	203 = Allow/Forbid Frames
	204 = Allow/Forbid Images

	300 = Lock All Tabs
	301 = Block Referer from All Tabs
	302 = Auto Reload for All Tabs
*/
pref("browser.tabs.extensions.tabbar_ondblclick",               1);
pref("browser.tabs.extensions.tabbar_onmiddleclick",            113);
pref("browser.tabs.extensions.tabbar_on4thclick",               0);
pref("browser.tabs.extensions.tabbar_on5thclick",               0);

/* If you set to "true", following shortcuts are available:
	Shift+Alt+Up   : Focus to the previously selected tab
	Shift+Alt+Down : Focus to the next selected tab

	ex.:
	Tere are four tabs [A][B][C][D] and select [A]->[B]->[C]->[D],
	step 1. [Shift+Alt+Left]  > [C] is focused
	step 2. [Shift+Alt+Left]  > [B] is focused
	step 3. [Shift+Alt+Left]  > [A] is focused
	step 4. [Shift+Alt+Right] > [B] is focused
	step 5. [Shift+Alt+Right] > [C] is focused
	step 6. [Shift+Alt+Right] > [D] is focused
*/
pref("browser.tabs.extensions.focus_with_selected_order",      false);


pref("browser.tabs.extensions.show_progress",        true);
pref("browser.tabs.extensions.show_closebox",        false);
pref("browser.tabs.extensions.show_closebox_always", true);
pref("browser.tabs.extensions.show_blankspaces",     false);
// 0 = start, 1 = center, 2 = end
pref("browser.tabs.extensions.tabs_title_crop",      2);
// 0 = fit to window, 1 = fit to label, 2 = fix
pref("browser.tabs.extensions.tabs_width_type",      0);
pref("browser.tabs.extensions.tabs_width",           250);
pref("browser.tabs.extensions.tabs_min_width",       30);
pref("browser.tabs.extensions.tabs_max_width",       250);
// 0 = in left edge, 1 = left, 2 = right, 3 = in right edge
pref("browser.tabs.extensions.open_tab_in",          3);
pref("browser.tabs.extensions.open_tab_in_link",     -1); // same to above
// if true, the behavior of tab dragging/dropping goes back to the old behavior.
pref("browser.tabs.extensions.dragdrop.only_load_uri", false);

// same to "browser.tabs.extensions.tabbar_on***"
pref("browser.tabs.extensions.ondblclick",           0);
pref("browser.tabs.extensions.onmiddleclick",        4);
pref("browser.tabs.extensions.on4thclick",           0);
pref("browser.tabs.extensions.on5thclick",           0);

pref("browser.tabs.extensions.slow_down_autoreload_in_background.enabled", false);
pref("browser.tabs.extensions.slow_down_autoreload_in_background.rate", 5);


pref("browser.tabs.opentabfor.urlbar_always",              false);
pref("browser.tabs.opentabfor.anylink",                    false);
pref("browser.tabs.opentabfor.outerlink",                  false);
pref("browser.tabs.opentabfor.anybookmark",                false);
pref("browser.tabs.opentabfor.anyhistory",                 false);

pref("browser.tabs.extensions.observe.clipboard.enabled",  false);
pref("browser.tabs.extensions.observe.clipboard.interval", 500);
pref("browser.tabs.extensions.observe.clipboard.newTab",   false);


pref("browser.tabs.extensions.locked.enabled",               false);
pref("browser.tabs.extensions.referrerBlocked.enabled",      false);
pref("browser.tabs.extensions.allowPlugins.enabled",         true);
pref("browser.tabs.extensions.allowJavascript.enabled",      true);
pref("browser.tabs.extensions.allowMetaRedirects.enabled",   true);
pref("browser.tabs.extensions.allowSubframes.enabled",       true);
pref("browser.tabs.extensions.allowImages.enabled",          true);
pref("browser.tabs.extensions.overlay_icon",                 true);
pref("browser.tabs.extensions.keep_tab_status",              false);
pref("browser.tabs.extensions.control_refresh",              true);


pref("browser.tabs.extensions.bookmarks.use_fixed_label",    false);
pref("browser.tabs.extensions.bookmarks.open_child_folders", false);
pref("browser.tabs.extensions.bookmarks.save_status",        true);
pref("browser.tabs.extensions.bookmarks.save_permissions",   true);


pref("browser.tabs.extensions.loadInBackgroundBookmarks",   false);
pref("browser.tabs.extensions.loadInBackgroundHistory",     false);
pref("browser.tabs.extensions.loadInBackgroundLocationBar", false);
pref("browser.tabs.extensions.loadInBackgroundJS",          false);
pref("browser.tabs.extensions.loadInBackgroundNative",      false);
pref("browser.tabs.extensions.loadInBackgroundObserveClipbard", false);
pref("browser.tabs.extensions.loadInBackgroundOpenURIString_with_dblclick", false);

pref("browser.tabs.extensions.loadInBackgroundWindow",       false);
pref("browser.tabs.extensions.loadInBackgroundWindowNative", false);
pref("browser.tabs.extensions.loadInBackgroundWindowObserveClipbard", true);

/* next focused tab when the current tab is closed
	0 = left tab (Default at Moz1.0)
	1 = right tab (Default at Moz1.1)
	2 = focus to the previously made
	3 = focus to the previously selected
*/
pref("browser.tabs.extensions.direction_of_focusing",          1);
pref("browser.tabs.extensions.direction_of_focusing.in_group", true);
pref("browser.tabs.extensions.focus_with_mouseover",           false);
pref("browser.tabs.extensions.focus_with_mouseover.delay",     100);


pref("browser.tabs.extensions.showNewActiveTabItem",        true);
pref("browser.tabs.extensions.show_item.newTab",            true);
pref("browser.tabs.extensions.show_item.bookmarkGroup",     true);
pref("browser.tabs.extensions.show_item.reloadTab",         true);
pref("browser.tabs.extensions.show_item.reloadAll",         true);
pref("browser.tabs.extensions.show_item.moveLeft",          false);
pref("browser.tabs.extensions.show_item.moveRight",         false);
pref("browser.tabs.extensions.show_item.duplicateTab",      true);
pref("browser.tabs.extensions.show_item.duplicateInWindow", false);
pref("browser.tabs.extensions.show_item.setFixedLabelFor",  true);
pref("browser.tabs.extensions.show_item.lockTab",           true);
pref("browser.tabs.extensions.show_item.lockTabAll",        false);
pref("browser.tabs.extensions.show_item.blockReferrer",     false);
pref("browser.tabs.extensions.show_item.blockReferrerAll",  false);
pref("browser.tabs.extensions.show_item.autoreload",        true);
pref("browser.tabs.extensions.show_item.autoreloadAll",     false);
pref("browser.tabs.extensions.show_item.allow",             true);
pref("browser.tabs.extensions.show_item.removeTab",         true);
pref("browser.tabs.extensions.show_item.removeTabGroup",    false);
pref("browser.tabs.extensions.show_item.removeLeft",        true);
pref("browser.tabs.extensions.show_item.removeRight",       true);
pref("browser.tabs.extensions.show_item.removeAll",         false);
pref("browser.tabs.extensions.show_item.removeVisited",     false);
pref("browser.tabs.extensions.show_item.removeOther",       true);
pref("browser.tabs.extensions.show_item.undoRemoveTab",     true);
pref("browser.tabs.extensions.show_item.editBookmark",      false);
pref("browser.tabs.extensions.show_item.sortTabsByGroup",   false);
pref("browser.tabs.extensions.show_item.highlightGroup",    false);
pref("browser.tabs.extensions.show_item.setTabColorFor",  true);
pref("browser.tabs.extensions.show_item.editMenu",          true);
//pref("browser.tabs.extensions.show_context.openLinkInNewActiveTab",  true);
pref("browser.tabs.extensions.show_context.openAllLinksInTabs",      true);
pref("browser.tabs.extensions.show_context.openAllLinksInGroup",     true);
pref("browser.tabs.extensions.show_context.bookmarkAllLinksAsGroup", true);
pref("browser.tabs.extensions.show_context.bookmarkTabGroup",        true);


pref("browser.tabs.extensions.group.enabled",                     false);
pref("browser.tabs.extensions.group.auto_purge_root",             false);
pref("browser.tabs.extensions.group.auto_purge",                  false);
pref("browser.tabs.extensions.group.auto_color",                  true);
pref("browser.tabs.extensions.group.edit_simple_dragdrop",        false);
pref("browser.tabs.extensions.group.open_bookmarkgroup_as_group", true);
/*
	0: append to current tabset
	1: insert to current group
	10: replace all tabs
	11: replace current group
	20: replace current tab when only one tab is open
		(normally append to current tabset)
	21: replace current tab when only one tab is open
		(normally insert to current group)
*/
pref("browser.tabs.extensions.bookmarkgroup_behavior",            0);
